/*
Copyright (C) 2009 Grant Slender

This file is part of OFCGWT.
http://code.google.com/p/ofcgwt/

OFCGWT is free software: you can redistribute it and/or modify
it under the terms of the Lesser GNU General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

OFCGWT is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

See <http://www.gnu.org/licenses/lgpl-3.0.txt>.
 */
package com.rednels.ofcgwt.client.model;

import com.google.gwt.json.client.JSONValue;

/**
 * An interface that objects that build JSON strings should implement
 */
public interface JSONizable {

	/**
	 * Build (and return) a JSONObject that contains all the items of this
	 * object. If required, will call.buildJSON() on any contained JSONizable
	 * objects, thus producing an entire JSON tree.
	 * 
	 * @return the JSONObject
	 */
	public JSONValue buildJSON();

}