package org.adamtacy.client.ui.effects.core;

import org.adamtacy.client.ui.effects.impl.browsers.EffectImplementation;

import com.google.gwt.dom.client.Element;

public class NChangeBinaryAction implements ChangeInterface {

  boolean changed = true;

  /** The end number */
  String end = "Arial";

  /** The start number */
  String start = "Times";

  String styleComponentToChange = "";
  double switchFrame;

  public NChangeBinaryAction() {
  }

  public NChangeBinaryAction(String styleStart, String styleEnd) {
    this.setStartValue(styleStart);
    this.setEndValue(styleEnd);
  }

  public void performStep(Element effectElement, String styleComponentToChange,
      double progress) {
    if ((progress > switchFrame) && (!changed)) {
      EffectImplementation.changeFixedStyleAttribute(effectElement,
          styleComponentToChange, end);
      changed = true;
    }
    if ((progress < switchFrame) && (changed)) {
      EffectImplementation.changeFixedStyleAttribute(effectElement,
          styleComponentToChange, start);
      changed = false;
    }
  }

  public void reset() {
    changed = false;
  }

  /** Change the ending number */
  public void setEndValue(String newEnd) {
    end = newEnd;
  }

  /** Change the starting number */
  public void setStartValue(String newStart) {
    start = newStart;
  }

  public void setUp(Element effectElement, String styleComponentToChange,
      double switchFrameNumber) {
    switchFrame = switchFrameNumber;
    this.performStep(effectElement, styleComponentToChange, 0.0);
  }

  public void tearDownEffect(Element effectElement) {
  }

}
