package org.adamtacy.client.ui.effects.core;

import org.adamtacy.client.ui.effects.impl.browsers.EffectImplementation;
import org.adamtacy.client.ui.effects.impl.css.StyleImplementation;

import com.google.gwt.dom.client.Element;
import com.google.gwt.user.client.DOM;

public class NChangeScalarAction implements ChangeInterface {

  /** The current number */
  protected double current;

  /** The delta between start and end number */
  protected double delta;

  /** The end number */
  protected double end = 100;

  boolean isMoveable = false;

  boolean isOpacity = false;

  /** The start number */
  protected double start = 0;

  protected String styleToChange = "";
  protected String unitOfStyleComponent = "";

  public NChangeScalarAction() {
  }

  public NChangeScalarAction(String styleStart, String styleEnd) {
    this.setStartValue(styleStart);
    this.setEndValue(styleEnd);
  }

  public String getUnitOfStyleComponent() {
    return unitOfStyleComponent;
  }

  public double getValue(double curr) {
    return start + (curr * (end - start));
  }

  public void performStep(Element effectElement, String styleComponentToChange,
      double progress) {
    double val = getValue(progress);
    if (!isOpacity)
      EffectImplementation.changeNumericalStyleAttribute(effectElement,
          styleToChange, val, unitOfStyleComponent);
    else
      EffectImplementation.setOpacity(effectElement, val);
  }

  /** Reset the effect */
  public void reset() {
  }

  /** Change the ending number */
  public void setEndValue(String newEnd) {
    unitOfStyleComponent = StyleImplementation.getUnits(newEnd);
    end = Double.parseDouble(StyleImplementation.getValue(newEnd,
        unitOfStyleComponent));
  }

  /** Change the starting number */
  public void setStartValue(String newStart) {
    unitOfStyleComponent = StyleImplementation.getUnits(newStart);
    start = Double.parseDouble(StyleImplementation.getValue(newStart,
        unitOfStyleComponent));
  }

  public void setUp(Element effectElement, String styleComponentToChange,
      double switchFrameNumber) {
    styleToChange = styleComponentToChange;
    if (styleComponentToChange.equals("opacity"))
      isOpacity = true;
    if (styleComponentToChange.equals("left"))
      isMoveable = true;
    if (styleComponentToChange.equals("top"))
      isMoveable = true;
    if (styleComponentToChange.equals("right"))
      isMoveable = true;
    if (styleComponentToChange.equals("bottom"))
      isMoveable = true;
    if (isMoveable) {
      EffectImplementation.setMoveable(effectElement, true);
    }
    this.performStep(effectElement, styleComponentToChange, 0.0);
  }

  public void tearDownEffect(Element effectElement) {
    if (isMoveable) {
      DOM.setStyleAttribute((com.google.gwt.user.client.Element) effectElement,
          "top", effectElement.getParentElement().getAbsoluteTop() + "px");
      DOM.setStyleAttribute((com.google.gwt.user.client.Element) effectElement,
          "left", effectElement.getParentElement().getAbsoluteLeft() + "px");
      EffectImplementation.setMoveable(effectElement, false);
    }
    if (isOpacity) {
      EffectImplementation.setOpacity(effectElement, 100.0);
    }
  }
}
