/*
 * Copyright 2008 Adam Tacy <adam.tacy AT gmail.com>
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.adamtacy.client.ui.effects.core;

import org.adamtacy.client.ui.effects.NEffect;

import com.google.gwt.dom.client.Element;

/**
 * 
 * 
 */
public class NMorphBinary extends NEffect {

  public void setPosition(double progress){
    double val = interpolate(progress);
    this.onUpdate(val);
}
  
  /** Change the ending number */
  public void setEndValue(String newEnd) {
    binaryStyleImpl.setEndValue(newEnd);
    if ((thePanel!=null) && thePanel.isAttached()) setUpEffect();
  }

  /** Change the starting number */
  public void setStartValue(String newStart) {
    binaryStyleImpl.setStartValue(newStart);
    if ((thePanel!=null) && thePanel.isAttached()) setUpEffect();
  }
  
  /**
   * Inner class that allows user to set properties of Effect.
   * @deprecated
   */
  public class BinaryProperties extends BaseProperties {
    /** Change the ending number 
     * @deprecated*/
    public void setEndValue(String newEnd) {
      binaryStyleImpl.setEndValue(newEnd);
    }

    /** Change the starting number 
     * @deprecated*/
    public void setStartValue(String newStart) {
      binaryStyleImpl.setStartValue(newStart);
    }
  }

  NChangeBinaryAction binaryStyleImpl = new NChangeBinaryAction();

  Element effectElement;

  protected String styleComponentToChange = "";

  /**
   * Internal copy of the properties object
   * @deprecated
   */
  private BinaryProperties theFixedProperties = new BinaryProperties();

  double threshold = 0.5;

  public NMorphBinary(String styleName) {
    super();
    styleComponentToChange = styleName;
  }

  public NMorphBinary(String styleName, String styleStart, String styleEnd) {
    this(styleName);
    if (!styleStart.equals("")) {
      setStartValue(styleStart);
    }
    setEndValue(styleEnd);
  }

  /**
   * Allow the user to retrieve a copy of the properties object.
   * 
   * @return NumberProperties object
   * @deprecated
   */
  public BinaryProperties getProperties() {
    if (theFixedProperties==null)theFixedProperties = new BinaryProperties();
    return theFixedProperties;
  }

  @Override
  protected void onUpdate(double progress) {
    super.onUpdate(progress);
    binaryStyleImpl.performStep(effectElement, styleComponentToChange, progress);
  }

  /** Reset the effect */
  @Override
  public void reset() {
    binaryStyleImpl.performStep(effectElement, styleComponentToChange, 0);
    binaryStyleImpl.reset();
  }

  @Override
  protected void setUpEffect() {
    effectElement = thePanel.getPanelWidget().getElement();
    binaryStyleImpl.setUp(effectElement, styleComponentToChange, threshold);
    reset();
  }

  @Override
  public void tearDownEffect() {
    binaryStyleImpl.tearDownEffect(effectElement);
  }
}