/*
 * Copyright 2008 Adam Tacy <adam.tacy AT gmail.com>
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.adamtacy.client.ui.effects.core;

import org.adamtacy.client.ui.effects.NEffect;

/**
 * 
 * 
 */
public class NMorphScalar extends NEffect {

  public void setPosition(double progress){
    double val = interpolate(progress);
    this.onUpdate(val);
  }
  
  
  public double getEndValue() {
    return scalarStyleImpl.end;
  }

  public double getStartValue() {
    return scalarStyleImpl.start;
  }

  /** Change the ending number */
  public void setEndValue(String newEnd) {
    scalarStyleImpl.setEndValue(newEnd);
    if ((thePanel!=null) && thePanel.isAttached()) setUpEffect();
  }

  /** Change the starting number */
  public void setStartValue(String newStart) {
    scalarStyleImpl.setStartValue(newStart);
    if ((thePanel!=null) && thePanel.isAttached()) setUpEffect();
  }
  
  /**
   * Inner class that allows user to set properties of Effect.
   * @deprecated
   */
  public class NumberProperties extends BaseProperties {
    
    /**
     * @deprecated
     */
    public double getEndValue() {
      return scalarStyleImpl.end;
    }

    public double getStartValue() {
      return scalarStyleImpl.start;
    }

    /** Change the ending number 
     * @deprecated
     * */
    public void setEndValue(String newEnd) {
      scalarStyleImpl.setEndValue(newEnd);
      if (thePanel != null)
        if (thePanel.isAttached())
          setUpEffect();
    }

    /** Change the starting number 
     * @deprecated
     * 
     */
    public void setStartValue(String newStart) {
      scalarStyleImpl.setStartValue(newStart);
      if (thePanel != null)
        if (thePanel.isAttached())
          setUpEffect();
    }
  }

  NChangeScalarAction scalarStyleImpl = new NChangeScalarAction();

  protected String styleComponentToChange = "";

  /**
   * Internal copy of the properties object
   * @deprecated
   */
  private NumberProperties theNumberProperties = new NumberProperties();

  public NMorphScalar(String styleName) {
    super();
    styleComponentToChange = styleName;
  }

  public NMorphScalar(String styleName, String styleStart, String styleEnd) {
    this(styleName);
    if (!styleStart.equals("")) {
      setStartValue(styleStart);
    }
    setEndValue(styleEnd);
  }
  
  

  /**
   * Allow the user to retrieve a copy of the properties object.
   * 
   * @return NumberProperties object
   * @deprecated
   */
  public NumberProperties getMorphProperties() {
    return theNumberProperties;
  }

  @Override
  protected void onUpdate(double progress) {
    super.onUpdate(progress);
    scalarStyleImpl.performStep(effectElement, styleComponentToChange, progress);
  }

  @Override
  protected void setUpEffect() {
    effectElement = thePanel.getPanelWidget().getElement();
    scalarStyleImpl.setUp(effectElement, styleComponentToChange, 0);
  }

  @Override
  public void tearDownEffect() {
    scalarStyleImpl.tearDownEffect(effectElement);
  }
}