package org.adamtacy.client.ui.effects.events;

import com.google.gwt.event.shared.GwtEvent;

public class EffectSteppingEvent extends GwtEvent<EffectSteppingHandler> {
  private static Type<EffectSteppingHandler> TYPE = new Type<EffectSteppingHandler>();

  protected void fire(HasEffectSteppingEventHandlers source) {  
    source.fireEvent(new EffectSteppingEvent());
  }
  
  /**
   * Gets the event type associated with load events.
   * 
   * @return the handler type
   */
  public static com.google.gwt.event.shared.GwtEvent.Type<EffectSteppingHandler> getType() {
    return TYPE;
  }

  @Override
  public com.google.gwt.event.shared.GwtEvent.Type<EffectSteppingHandler> getAssociatedType() {
    return TYPE;
  }

  @Override
  protected void dispatch(EffectSteppingHandler handler) {
    handler.onEffectStep(this);
  } 
  
  private double progress = 0;
  
  public EffectSteppingEvent(double progress){
    this.progress = progress;
  }
  
  public EffectSteppingEvent(){
  }
  
  public double getProgress(){
    return progress;
  }

}
