/*
 * Copyright 2008 Adam Tacy <adam.tacy AT gmail.com>
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.adamtacy.client.ui.effects.impl;

import org.adamtacy.client.ui.effects.core.NMorphStyle;
import org.adamtacy.client.ui.effects.impl.css.Rule;

import com.google.gwt.user.client.DOM;

public class Move extends NMorphStyle {

  /**
   * Inner class that allows user to set properties of Effect.
   * @deprecated
   */
  public class MoveProperties extends StyleProperties {
    /**
     * @deprecated
     * @return
     */
    public int getXValue() {
      return moveX;
    }

    /**
     * @deprecated
     * @return
     */
    public int getYValue() {
      return moveY;
    }

    /** Change the starting number 
     * @deprecated*/
    public void setXValue(int newX) {
      moveX = newX;
      if (thePanel != null)
        if (thePanel.isAttached())
          setUpEffect();
    }

    /** Change the ending number 
     * @deprecated*/
    public void setYValue(int newY) {
      moveY = newY;
      if (thePanel != null)
        if (thePanel.isAttached())
          setUpEffect();
    }
  }
  
  public int getXValue() {
    return moveX;
  }

  public int getYValue() {
    return moveY;
  }

  /** Change the starting number */
  public void setXValue(int newX) {
    moveX = newX;
    if (thePanel != null)
      if (thePanel.isAttached())
        setUpEffect();
  }

  /** Change the ending number */
  public void setYValue(int newY) {
    moveY = newY;
    if (thePanel != null)
      if (thePanel.isAttached())
        setUpEffect();
  }
  
  public void setUpEffect(){
    theEnd = new Rule("endMove{left: "
        + (moveX) + "px; top: " + (moveY) + "px;}");
    this.registerProperties(theStart, theEnd);
    super.setUpEffect();
  }

  int moveX, moveY;

  /**
   * Internal copy of the properties object
   * @deprecated
   */
  private MoveProperties theMoveProperties = new MoveProperties();
  
  public Move(int x, int y) {
    super(new Rule("startMove{left:0px; top:0px;}"), new Rule("endMove{left: "
        + (x) + "px; top: " + (y) + "px;}"));
    moveX = x;
    moveY = y;
  }

  public Move(Rule startEntry, Rule endEntry) {
    super(startEntry, endEntry);
  }

  /**
   * Allow the user to retrieve a copy of the properties object.
   * 
   * @return NumberProperties object
   * @deprecated
   */
  public MoveProperties getProperties() {
    return theMoveProperties;
  }

  @Override
  public void tearDownEffect() {
    DOM.setStyleAttribute((com.google.gwt.user.client.Element) effectElement, "top", DOM.getStyleAttribute(thePanel.getElement(),"top"));
    DOM.setStyleAttribute((com.google.gwt.user.client.Element) effectElement, "left", DOM.getStyleAttribute(thePanel.getElement(),"left"));
  }
}
