/*
 * Copyright 2008 Adam Tacy <adam.tacy AT gmail.com>
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.adamtacy.client.ui.effects.impl.css;

import com.google.gwt.core.client.GWT;

/**
 * A class to represent a Selector and rule in a style sheet.
 * 
 * @author Adam Tacy
 * @version 3.0
 * 
 */
public class Selector {

  static StyleSheetImplementationStandard styleSheetImpl = (StyleSheetImplementationStandard) GWT.create(StyleSheetImplementationStandard.class);

  private Rule ruleDefinition;
  private String selector;

  public Selector(final String selector) {
    ruleDefinition = new Rule(styleSheetImpl.getStyle(selector).toString());
    // We should have a value here - if not, throw a runtime exception.
    if (ruleDefinition.equals(""))
      throw new RuntimeException("Unable to find rule matching: " + selector);
  }

  public Rule getRuleDefinition() {
    return ruleDefinition;
  }

  public String getSelector() {
    return selector;
  }

  @Override
  public String toString() {
    return selector + ruleDefinition.toString();
  }
}
